/*============================================================================
  File:     RestoreOnSQLDEV02.sql

  Summary:  Show various facets of TDE

  Date:     March 2008

  SQL Server Version: 10.0.1300.13 (Katmai February CTP - CTP-6)
------------------------------------------------------------------------------
  Written by Kimberly L. Tripp & Paul S. Randal, SQLskills.com

  For more scripts and sample code, check out http://www.SQLskills.com

  This script is intended as a supplement to the SQL Server 2008 Jumpstart or
  Metro training.
  
  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.
============================================================================*/

-- Make sure the connection is to SQLDEV02

-- Try to restore the backup of the encrypted database
RESTORE DATABASE MySecureDataEncrypted
FROM DISK = 'C:\SQLskills\MySecureDataEncrypted.bak'
WITH MOVE 'MySecureData' TO
	'C:\Program Files\Microsoft SQL Server\MSSQL10.SQLDEV02\MSSQL\DATA\MySecureDataEncrypted.mdf',
MOVE 'MySecureData_log' TO
	'C:\Program Files\Microsoft SQL Server\MSSQL10.SQLDEV02\MSSQL\DATA\MySecureDataEncrypted_log.ldf',
REPLACE;
GO

-- Ah - no server certificate.
CREATE CERTIFICATE MyServerSert
FROM FILE = 'C:\SQLskills\MyServerCert'
WITH PRIVATE KEY (FILE = 'C:\SQLskills\MyServerCertKey',
	DECRYPTION BY PASSWORD = 'PSRxKLT@07292007');
GO

-- Oops we need to create a master key
CREATE MASTER KEY ENCRYPTION BY
PASSWORD = 'Sligachan*02*';
GO

-- And try to create the certificate again
CREATE CERTIFICATE MyServerSert
FROM FILE = 'C:\SQLskills\MyServerCert'
WITH PRIVATE KEY (FILE = 'C:\SQLskills\MyServerCertKey',
	DECRYPTION BY PASSWORD = 'PSRxKLT@07292007');
GO

-- That's better. Now let's try again:
RESTORE DATABASE MySecureDataEncrypted
FROM DISK = 'C:\SQLskills\MySecureDataEncrypted.bak'
WITH MOVE 'MySecureData' TO
	'C:\Program Files\Microsoft SQL Server\MSSQL10.SQLDEV02\MSSQL\DATA\MySecureDataEncrypted.mdf',
MOVE 'MySecureData_log' TO
	'C:\Program Files\Microsoft SQL Server\MSSQL10.SQLDEV02\MSSQL\DATA\MySecureDataEncrypted_log.ldf',
REPLACE;
GO

-- And try to get some data
SELECT * FROM MySecureDataEncrypted.dbo.MySecureTable;
GO
