/*============================================================================
  File:     SetupEncryptedSalesDB.sql

  Summary:  Create a copy of SalesDB and encrypt it

  Date:     March 2008

  SQL Server Version: 10.0.1300.13 (Katmai February CTP - CTP-6)
------------------------------------------------------------------------------
  Written by Kimberly L. Tripp & Paul S. Randal, SQLskills.com

  For more scripts and sample code, check out http://www.SQLskills.com

  This script is intended as a supplement to the SQL Server 2008 Jumpstart or
  Metro training.
  
  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.
============================================================================*/

BACKUP DATABASE SalesDB TO
DISK = N'C:\SQLskills\Salesdb.bak'
WITH INIT;
GO

-- sp_helpdb 'SalesDB'

RESTORE DATABASE SalesDBEncrypted 
FROM DISK = N'C:\SQLskills\SalesDB.bak' WITH
MOVE 'SalesDBData' TO
	N'C:\Program Files\Microsoft SQL Server\MSSQL10.SQLDEV01\MSSQL\DATA\SalesDBEncrypted.mdf',
MOVE 'SalesDBLog' TO
	N'C:\Program Files\Microsoft SQL Server\MSSQL10.SQLDEV01\MSSQL\DATA\SalesDBEncrypted_log.ldf',
REPLACE;
GO

USE master;
GO

-- Encrypt the database copy
CREATE MASTER KEY ENCRYPTION BY
PASSWORD = 'Sligachan*01*';
GO

CREATE CERTIFICATE MySalesDBCert
WITH SUBJECT = 'My DEK Certificate';
GO

USE SalesDBEncrypted;
GO

CREATE DATABASE ENCRYPTION KEY
WITH ALGORITHM = AES_128
ENCRYPTION BY SERVER CERTIFICATE MySalesDBCert;
GO

ALTER DATABASE SalesDBEncrypted
SET ENCRYPTION ON;
GO

-- See if encryption has completed yet
SELECT * FROM sys.dm_database_encryption_keys
WHERE [database_id] = DB_ID ('SalesDBEncrypted');
GO
-- Encryption state of 3 means it's encrypted, 2 means
-- encryption is still in progress. Wait till it's 3
